/* GP.cpp
 *
 *  Created on: Oct 26, 2013
 *      Author: nghiaht
 */

#include "GP.h"

GP::GP(IsoGaussian* covfunc)
{
    this->covfunc = covfunc;
}

void GP::train(Mat &X, Vec &Y)
{
    this->X = X; this->Y = Y;

    if (this->X.size() == 0) return;

    Mat K = this->covfunc->Eval(X);
    this->L = Cholesky(K); Mat Lt = Trans(L);

    Vec beta = ForwardSub(this->L, Y);
    this->alpha = BackwardSub(Lt, beta);
}

pair <double, double> GP::pointwise_prediction(Vec &x)
{
	if (this->X.size() == 0) return make_pair(0, covfunc->Var(x));

    Vec k = covfunc->Eval(x, this->X), v = ForwardSub(this->L, k);
    double mean = Dot(k, this->alpha), variance = covfunc->Var(x) - Dot(v, v);
    return make_pair(mean, variance);
}

Vec GP::generate_outcome(Vec &x, int C)
{
    pair <double, double> predict = pointwise_prediction(x);
    return grand(predict.first, predict.second, C);
}



