/*
 * Node.h
 *
 *  Created on: Oct 26, 2013
 *      Author: nghiaht
 */

#ifndef NODE_H_
#define NODE_H_

#include "Factory.h"

#define NSAMPLE 8
#define BIAS 0.5

class Node
{
	private:

	int n; // remaining sensing budget
	int dx; // previously collected location
	double dy; // previously collected measurement

	Node* boss; // immediate parent node
	Factory* company; // pointer to the class of common resources to all nodes

	vector <Node*> subordinates;
	Vec dCost, b;

	double UB, LB;
	int selected;

	void InitializeBounds();
	void BaseCase();

	public:

	Node(int n, int dx, double dy, Node* parent, Factory* company, Vec &b);
	Node(int n, int dx, double dy, Node* parent, Factory* company, Vec &b, double LB, double UB);
	~Node();

	Node* Boss();
	int Budget();
	void Trace(Node *current, Vec &X, Vec &Y);

	void UpdateBounds();
	void Explore();

	int NextLocation();
	pair <int, double> LastObservation();
	pair <double, double> GetBounds();
	double BoundGap();

	vector <Node*> Report();
};

#endif /* NODE_H_ */
